(function () {
    "use strict";

    angular.module('core').controller('classificacaoTributariaIBSCBSController', controller);
    controller.$inject = ['$scope', '$timeout', 'classificacaoTributariaIBSCBSService'];

    function controller($scope, $timeout, classificacaoTributariaIBSCBSService) {
        $scope.initializeLayout('Classificação tributária IBS CBS');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: null,
                    filtroAte: null,
                    filtroEm: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.arquivoSelecionado = null;
        $scope.arquivoSelecionadoNome = null;
        $scope.carregandoUpload = false;
        $scope.showModalImportCSV = false;

        $scope.toggleModalImportCSV = function () {
            $scope.showModalImportCSV = !$scope.showModalImportCSV;
        }
        // Chamado quando o usuário escolhe o arquivo no input
        $scope.onFileSelect = function (files) {
            if (!files || !files.length) {
                $scope.arquivoSelecionado = null;
                $scope.arquivoSelecionadoNome = null;
                return;
            }

            // como estamos chamando via onchange direto no DOM, precisa do $apply
            $scope.$apply(function () {
                $scope.arquivoSelecionado = files[0];
                $scope.arquivoSelecionadoNome = files[0].name;
            });
        };


        $scope.uploadCSV = function () {
            debugger
            $scope.carregandoUpload = true;
            classificacaoTributariaIBSCBSService
                .uploadCSV($scope.arquivoSelecionado)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            
                        } else {
                            $scope.tools.toastr.error("Arquivo importado com sucesso!", 'Serviço');
                        }
                        $scope.carregandoUpload = false;
                    },
                    function (_error) {
                        $scope.carregandoUpload = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            classificacaoTributariaIBSCBSService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            classificacaoTributariaIBSCBSService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            debugger
            if ($scope.state.count == 0)
                return
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            if ($scope.state.count <= $scope.state.filtro.args.skip)
                return;
            classificacaoTributariaIBSCBSService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
            $scope.state.filtro.ativo = false;
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                filtroEm: null,
                sortExpression: '',
                skip: 0,
                take: 20
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();